# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::TrafficManager::Mgmt::V2018_04_01
  module Models
    #
    # Class representing a Traffic Manager profile.
    #
    class Profile < TrackedResource

      include MsRestAzure

      # @return [ProfileStatus] The status of the Traffic Manager profile.
      # Possible values include: 'Enabled', 'Disabled'
      attr_accessor :profile_status

      # @return [TrafficRoutingMethod] The traffic routing method of the
      # Traffic Manager profile. Possible values include: 'Performance',
      # 'Priority', 'Weighted', 'Geographic', 'MultiValue', 'Subnet'
      attr_accessor :traffic_routing_method

      # @return [DnsConfig] The DNS settings of the Traffic Manager profile.
      attr_accessor :dns_config

      # @return [MonitorConfig] The endpoint monitoring settings of the Traffic
      # Manager profile.
      attr_accessor :monitor_config

      # @return [Array<Endpoint>] The list of endpoints in the Traffic Manager
      # profile.
      attr_accessor :endpoints

      # @return [TrafficViewEnrollmentStatus] Indicates whether Traffic View is
      # 'Enabled' or 'Disabled' for the Traffic Manager profile. Null,
      # indicates 'Disabled'. Enabling this feature will increase the cost of
      # the Traffic Manage profile. Possible values include: 'Enabled',
      # 'Disabled'
      attr_accessor :traffic_view_enrollment_status

      # @return [Integer] Maximum number of endpoints to be returned for
      # MultiValue routing type.
      attr_accessor :max_return


      #
      # Mapper for Profile class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Profile',
          type: {
            name: 'Composite',
            class_name: 'Profile',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              location: {
                client_side_validation: true,
                required: false,
                serialized_name: 'location',
                type: {
                  name: 'String'
                }
              },
              profile_status: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.profileStatus',
                type: {
                  name: 'String'
                }
              },
              traffic_routing_method: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.trafficRoutingMethod',
                type: {
                  name: 'String'
                }
              },
              dns_config: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.dnsConfig',
                type: {
                  name: 'Composite',
                  class_name: 'DnsConfig'
                }
              },
              monitor_config: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.monitorConfig',
                type: {
                  name: 'Composite',
                  class_name: 'MonitorConfig'
                }
              },
              endpoints: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.endpoints',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'EndpointElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'Endpoint'
                      }
                  }
                }
              },
              traffic_view_enrollment_status: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.trafficViewEnrollmentStatus',
                type: {
                  name: 'String'
                }
              },
              max_return: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.maxReturn',
                type: {
                  name: 'Number'
                }
              }
            }
          }
        }
      end
    end
  end
end
